# Clocks

# UCLK=25 ns is used by LHC
# UCLK=1/(66MHz) is used by S32PCI64-SOLAR

create_clock -name "UCLK" -period 25.000ns [get_ports {UCLK}]
#create_clock -name "UCLK" -period 15.151ns [get_ports {UCLK}]
create_clock -name "SLOWCLK" -period 20.000ns [get_ports {SLOWCLK}]
create_clock -name "REFCLK0" -period 10.000ns [get_ports {REFCLK0}]
create_clock -name "REFCLK1" -period 10.000ns [get_ports {REFCLK1}]
create_clock -name "PLLCLK0" -period 10.000ns [get_ports {PLLCLK0}]
create_clock -name "PLLCLK1" -period 10.000ns [get_ports {PLLCLK1}]

# Specify asynchronous clock domains
set_clock_groups -asynchronous \
	-group [get_clocks { \
		REFCLK0 \
		REFCLK1 \
		}] \
	-group [get_clocks {UCLK}] \
	-group [get_clocks {SLOWCLK}] \
	-group [get_clocks {PLLCLK0}] \
	-group [get_clocks {PLLCLK1}]

# Automatically constrain PLL and other generated clocks
derive_pll_clocks -create_base_clocks

# Automatically calculate clock uncertainty to jitter and other effects.
derive_clock_uncertainty

# Set timing constraints for the FIFOs
# [http://www.altera.com/support/kdb/solutions/rd12032007_130.html]
set_false_path -from [get_registers {*dcfifo*delayed_wrptr_g[*]}] -to  [get_registers {*dcfifo*rs_dgwp*}]
set_false_path -from [get_registers {*dcfifo*rdptr_g[*]}] -to [get_registers {*dcfifo*ws_dgrp*}]

##################################################################
# WARNING: 12/28/2011 - the following constraints have been commented out
#          because they were completely random!
##################################################################
# Set input/output constraints
# [http://www.altera.com/literature/an/an433.pdf]
# set timing constants
# create virtual clocks for the constraints
#create_clock -period 25.0 -name virt_uclk
#create_clock -period 20.0 -name virt_iclk_2
#create_clock -period 10.0 -name virt_rx_clk
# apply input constraints
#set_input_delay -min 1.0 -clock virt_uclk [get_ports {UD[*] URESET_N UTEST_N UCTRL_N UWEN_N}]
#set_input_delay -max 1.4 -clock virt_uclk [get_ports {UD[*] URESET_N UTEST_N UCTRL_N UWEN_N}]
# apply output constraints (random values for now)
#set_output_delay 1.0 -clock virt_uclk [get_ports {LFF_N}]
#set_output_delay 1.0 -clock virt_rx_clk [get_ports {LRL[*]}]
#set_output_delay 1.0 -clock virt_iclk_2 [get_ports {LDOWN_N}]
