# possible modes: default, debug, error
if {$argc >= 1} {
	set mode $1
} else {
	set mode "default"
}

quit -sim

vlib work
vlib gate_work
vlib hola_sim_lib

# compile altera components
vcom -93 -work work {lsc_count_simulator.vhd}

vsim work.lsc_count_simulator -GNDATA=20

delete wave *

add wave -noupdate \
{sim:/lsc_count_simulator/power_up_rst_n } \
{sim:/lsc_count_simulator/tx_clk } \
{sim:/lsc_count_simulator/rx_clk }

add wave -noupdate -divider INTERNAL_TX
add wave -noupdate \
{sim:/lsc_count_simulator/pres_state } \
{sim:/lsc_count_simulator/do_idle_cnt } \
{sim:/lsc_count_simulator/do_data_cnt } \
{sim:/lsc_count_simulator/idle_cnt_done } \
{sim:/lsc_count_simulator/data_cnt_done }

add wave -noupdate -radix decimal \
{sim:/lsc_count_simulator/data_cnt_val }

add wave -noupdate -divider OUTPUT_TX 
add wave -noupdate -radix hexadecimal \
{sim:/lsc_count_simulator/TXD }
add wave -noupdate {sim:/lsc_count_simulator/TX_EN } {sim:/lsc_count_simulator/TX_ER }

add wave -noupdate -divider OUTPUT_RX
add wave -noupdate\
{sim:/lsc_count_simulator/rx_dv } \
{sim:/lsc_count_simulator/rx_er } 
add wave -noupdate -radix decimal \
{sim:/lsc_count_simulator/rxd } \
{sim:/lsc_count_simulator/rxd_last } 
add wave -noupdate {sim:/lsc_count_simulator/valid }


# tx stuff
force -freeze sim:/lsc_count_simulator/power_up_rst_n 0 0ns, 1 20ns
force -freeze sim:/lsc_count_simulator/tx_clk 0 0ns, 1 5ns -repeat 10ns
force -freeze sim:/lsc_count_simulator/rx_clk 0 0ns, 1 5ns -repeat 10ns

# rx stuff
force -freeze sim:/lsc_count_simulator/RX_DV 0 0ns, 1 100ns
force -freeze sim:/lsc_count_simulator/RX_ER 1 0ns, 0 100ns
#force -freeze sim:/lsc_count_simulator/RXD 16#0000 0ns, 16#0001 100ns, 16#0002 110ns, 16#0003 120ns, 16#0004 130ns
force -freeze sim:/lsc_count_simulator/RXD 16#0000 0ns

for { set i 0 } { $i <= 20 } { incr i } {
	set xns "[expr $i \* 10 + 100]ns"
	set val "10#[format %04d $i]"
	force -freeze sim:/lsc_count_simulator/RXD $val $xns
}
force -freeze sim:/lsc_count_simulator/RX_DV 1 310ns
force -freeze sim:/lsc_count_simulator/RX_ER 1 310ns

force -freeze sim:/lsc_count_simulator/RX_DV 1 360ns
force -freeze sim:/lsc_count_simulator/RX_ER 0 360ns
for { set i 0 } { $i <= 10 } { incr i } {
	set xns "[expr $i \* 10 + 360]ns"
	set val "10#[format %04d $i]"
	force -freeze sim:/lsc_count_simulator/RXD $val $xns
}
#introduce error
for { set i 11 } { $i <= 20 } { incr i } {
	set xns "[expr $i \* 10 + 360]ns"
	set val "10#[format %04d [expr $i + 1]]"
	force -freeze sim:/lsc_count_simulator/RXD $val $xns
}




run 1000 ns
view wave
update
WaveRestoreZoom {0 ps} {1000 ns}
