# possible modes: default, debug, error
if {$argc >= 1} {
	set mode $1
} else {
	set mode "default"
}

quit -sim

vlib work
vlib gate_work
vlib hola_sim_lib

# compile altera components
vcom -93 -work work {lsc_rres_simulator.vhd}

vsim work.lsc_rres_simulator

delete wave *

add wave -noupdate \
{sim:/lsc_rres_simulator/power_up_rst_n } \
{sim:/lsc_rres_simulator/tx_clk }
add wave -noupdate -radix hexadecimal {sim:/lsc_rres_simulator/TXD }
add wave -noupdate {sim:/lsc_rres_simulator/TX_EN } {sim:/lsc_rres_simulator/TX_ER }

force -freeze sim:/lsc_rres_simulator/power_up_rst_n 0 0ns, 1 20ns
force -freeze sim:/lsc_rres_simulator/tx_clk 0 0ns, 1 5ns -repeat 10ns

run 600 ns
view wave
update
WaveRestoreZoom {0 ps} {610 ns}
