module rst_gx (
	ref_clk,
	reset,
	gxb_pwrdn_in,
	cal_blk_clk,
	reconfig_clk,
	reconfig_togxb,
	rx_datain, 
	rx_seriallpbken,
	tx_datain,
	pll_locked, 
	reconfig_fromgxb,
	rx_clkout,
	rx_dataout,
	rx_freqlocked,
	rx_pll_locked,
	tx_clkout,
	tx_dataout
	);
	
	input			ref_clk;
	input			reset;
	input			gxb_pwrdn_in;
	input			cal_blk_clk;
	input			reconfig_clk;
	input	[3:0]	reconfig_togxb;
	input			rx_datain;
	input			rx_seriallpbken; 
	input 	[9:0]	tx_datain;
	
	output			pll_locked;
	output 	[16:0]	reconfig_fromgxb; 
	output			rx_clkout;
	output	[9:0]	rx_dataout;
	output			rx_freqlocked;
	output			rx_pll_locked;
	output			tx_clkout;
	output			tx_dataout;
	
	wire 			gxb_powerdown;
	wire 			tx_digitalreset;
	wire 			rx_analogreset;
	wire 			rx_digitalreset;
		
	gx_rst_ctrl gx_rst_ctrl_inst (
		.clk ( ref_clk ),
		.reset ( reset ),
		.gxb_pwrdn_in ( gxb_pwrdn_in ),
		.pll_locked ( pll_locked ),
		.rx_freqlocked ( rx_freqlocked ),
		.gxb_powerdown ( gxb_powerdown ),
		.tx_digitalreset ( tx_digitalreset ),
		.rx_analogreset ( rx_analogreset ),
		.rx_digitalreset ( rx_digitalreset )
	);
	
	gx gx_inst (
		.cal_blk_clk ( cal_blk_clk ),
		.gxb_powerdown ( gxb_powerdown ),
		.pll_inclk ( ref_clk ),
		.reconfig_clk ( reconfig_clk ),
		.reconfig_togxb ( reconfig_togxb ),
		.rx_analogreset ( rx_analogreset ),
		.rx_cruclk ( ref_clk ),
		.rx_datain ( rx_datain ),
		.rx_digitalreset ( rx_digitalreset ),
		.rx_seriallpbken ( rx_seriallpbken ),
		.tx_datain ( tx_datain ),
		.tx_digitalreset ( tx_digitalreset ),
		.pll_locked ( pll_locked ),
		.reconfig_fromgxb ( reconfig_fromgxb ),
		.rx_clkout ( rx_clkout ),
		.rx_dataout ( rx_dataout ),
		.rx_freqlocked ( rx_freqlocked ),
		.rx_pll_locked ( rx_pll_locked ),
		.tx_clkout ( tx_clkout ),
		.tx_dataout ( tx_dataout )
	);

endmodule 