quit -sim

# compile altera components
vcom -93 -work work {altgx_reco_single.vhd}
vcom -93 -work work {altgx_single.vhd}
# compile altgx wrappers
vcom -93 -work work {altgx_reset.vhd}
vcom -93 -work work {tb_gxss.vhd}

vsim work.tb_gxss(structure)

delete wave *

# general transmitter ports
add wave -noupdate \
{sim:/tb_gxss/slowclk } \
{sim:/tb_gxss/refclk } \
{sim:/tb_gxss/power_up_rst_n }

add wave -noupdate -divider gx_status
add wave \
{sim:/tb_gxss/tx_rstaa/pres_state } \
{sim:/tb_gxss/rx_rstaa/pres_state }

add wave -noupdate -divider data_sent
add wave -noupdate -label clk {sim:/tb_gxss/gx_instaa/tx_clkout(0)}
add wave -noupdate -radix hexadecimal -label txd {sim:/tb_gxss/txd }
add wave -noupdate -label tx_ctrl {sim:/tb_gxss/tx_ctrl }
add wave -noupdate -radix hexadecimal -label txsent \
{sim:/tb_gxss/gx_instaa/altgx_single_alt_c3gxb_component/transmit_pma0/datain } 

add wave -noupdate -divider data_received
add wave -noupdate -label rx_clkout {sim:/tb_gxss/gx_instaa/rx_clkout(0) }
add wave -noupdate -label rx_freqlocked {sim:/tb_gxss/gx_instaa/rx_freqlocked }
add wave -noupdate -radix hexadecimal -label rxreceived {sim:/tb_gxss/gx_instaa/altgx_single_alt_c3gxb_component/receive_pma0/rxdata }
add wave -noupdate -radix hexadecimal -label rx_dataout {sim:/tb_gxss/gx_instaa/rx_dataout }
add wave -noupdate -label rx_ctrldetect {sim:/tb_gxss/gx_instaa/rx_ctrldetect }
add wave -noupdate \
{sim:/tb_gxss/gx_instaa/rx_errdetect } \
{sim:/tb_gxss/gx_instaa/rx_disperr } \
{sim:/tb_gxss/gx_instaa/rx_runningdisp } \
{sim:/tb_gxss/gx_instaa/rx_patterndetect } \
{sim:/tb_gxss/gx_instaa/rx_syncstatus }


# clocks
force -freeze /tb_gxss/REFCLK  0 0ns, 1 5ns -repeat 10ns
force -freeze /tb_gxss/SLOWCLK  0 0ns, 1 10ns -repeat 20ns
force -freeze /tb_gxss/POWER_UP_RST_N 0 0ns, 1 18ns

# transmit (default test)
force -freeze /tb_gxss/tx_ctrl      11 0ns, 01      700ns,      11 740ns, 00      750ns,      10 1010ns
force -freeze /tb_gxss/txd     16#FFFF 0ns, 16#50BC 700ns, 16#FFFF 740ns, 16#0101 750ns, 16#BC02 1010ns

#transmit (test self-lock to 3 continuous valid-data words
#force -freeze /tb_gxss/tx_ctrl      00 0ns, 01      700ns,      11 740ns, 00      750ns,      10 1010ns
#force -freeze /tb_gxss/txd     16#FFFF 0ns, 16#50BC 700ns, 16#FFFF 740ns, 16#0101 750ns, 16#BC02 1010ns

run 1500ns
view wave
update
