-------------------------------------------------------------------------------
-- Configuration (functional)
-------------------------------------------------------------------------------

library work;
library work;
library hola_sim_lib;

configuration cfg_tb_link_functional_altera of tb_link is

  for structure

    for all: FEMB use entity hola_sim_lib.FEMB(ARCH)
      generic map (
        UCLK_HIGH      =>  12500 ps,  -- UCLK high time
        UCLK_LOW       =>  12500 ps,  -- UCLK low time
        DATA_SETUP     =>     10 ns,  -- Data setup time
        DATA_HOLD      =>      1 ns,  -- Data hold time
        ENABLE_SETUP   =>     10 ns,  -- Enable setup time
        ENABLE_HOLD    =>      1 ns,  -- Enable hold time
        MAX_CLK_TO_LFF =>     12 ns,  -- Maximum clock to Full flag
		FEMB_IN_FILENAME  => "femb_in.txt",
		FEMB_OUT_FILENAME => "out_link_femb_out.txt"
      );
    end for;
    
    -- to simulate the LSC, using Altera or Xilinx,
    -- simply change the generic "ALTERA_XILINX"
    for all : lsc_top use entity work.lsc_top(structure)
      generic map(
        SIMULATION        => 1,   -- simulation mode
        ALTERA_XILINX     => 1,   -- 1=Altera 0=Xilinx
		XCLK_FREQ         => 100, -- Reference clock oscillator frequency
		USE_PLL           => 1, 
        ACTIVITY_LENGTH   => 15,  -- ACTLED duration
        FIFODEPTH         => 64,  -- only powers of 2
        LOG2DEPTH         => 6,   -- 2log of depth
        FULLMARGIN        => 16   -- words left when LFF_N  set
      );
      for structure
        use work.all;
      end for;
    end for;
    
    -- to simulate the LDC, using Altera or Xilinx,
    -- simply change the generic "ALTERA_XILINX"
    for all : ldc_top use entity work.ldc_top(structure)
      generic map(
        ALTERA_XILINX    => 1,    -- 1=Altera 0=Xilinx
        SIMULATION       => 1,    -- simulation mode
        LCLK_SELECT      => 1,    -- LCLK generator selection
                                  -- 0 -> no clk gen. 1 -> 40MHz clk gen.
                                  -- 2 -> 62.5MHz clk gen.
		XCLK_FREQ        => 100,  -- Reference clock oscillator frequency
        ACTIVITY_LENGTH  => 15,   -- ACTLED duration
        FIFODEPTH        => 512,  -- only powers of 2
        LOG2DEPTH        => 9,    -- 2log of depth
        FULLMARGIN       => 256   -- words left when LFF_N set
      );
      for structure
        use work.all;
      end for;
    end for;

    for all : ROMB use entity hola_sim_lib.ROMB(ARCH)
      generic map(
        DATA_SETUP   =>  10 ns,  -- Data setup time
        DATA_HOLD    =>   0 ns,  -- Data hold  time
        ENABLE_SETUP =>  10 ns,  -- Enable setup time
        ENABLE_HOLD  =>   0 ns,  -- Enable hold  time
        CLOCK_PERIOD =>  25 ns,   -- Clock period
		ROMB_IN_FILENAME  => "romb_in.txt",
		ROMB_OUT_FILENAME => "out_link_romb_out.txt"
      );
    end for;

  end for;                              -- structure

end cfg_tb_link_functional_altera;
