# choose whether to apply deposit to prescales (for speedup)
set speedup "no"

transcript on
quit -sim

vlib work
vlib gate_work
vlib hola_sim_lib
vcom -93 -work hola_sim_lib {hola_sim_lib.vhd}

# compile general altera megafunctions
vcom -93 -work work {AFIFOLSC.vhd}
vcom -93 -work work {AFIFOLDC.vhd}
vcom -93 -work work {ACLK50_FROM_100.vhd}
vcom -93 -work work {ACLK40_FROM_100.vhd}

# compile hola
vcom -93 -work work {lrl_xoff_control.vhd}
vcom -93 -work work {core_holalsc.vhd}
vcom -93 -work work {core_holaldc.vhd}

# compile testbench
vcom -93 -work work {tb_oldlink.vhd}

vsim -quiet -t ps work.cfg_tb_oldlink_functional_altera

if {$speedup == "yes"} {
	force -deposit sim:/tb_oldlink/holaldc1/sim1/control_ldc_sim/prescale 000001 0 -cancel 100000
	force -deposit sim:/tb_oldlink/holalsc1/csim/control_sim/prescale 000001 0 -cancel 100000
}

delete wave *
add wave -noupdate -divider LSC_INPUTS
add wave -noupdate -in sim:/tb_oldlink/holalsc1/*
add wave -noupdate -divider LSC_OUTPUTS
add wave -noupdate -out sim:/tb_oldlink/holalsc1/*
add wave -noupdate -divider LDC_INPUTS
add wave -noupdate -in sim:/tb_oldlink/holaldc1/*
add wave -noupdate -divider LDC_OUTPUTS
add wave -noupdate -out sim:/tb_oldlink/holaldc1/*

run 60000ns
view wave
update
