#include <stdio.h>

#define NLAYER 6

struct Comb{
  int Hit[NLAYER];
};


struct Track{
  int PT   ;
  int PHI  ;
  int D0   ;
  int CHI  ;
};


struct ConstSet{
  int CHI0[NLAYER];
  int CHI1[NLAYER];
  int CHI2[NLAYER];

  int PT[NLAYER] ;
  int D0[NLAYER] ;
  int PHI[NLAYER];

  int IC_PT ;
  int IC_D0 ;
  int IC_PHI;

  int IC_CHI0;
  int IC_CHI1;
  int IC_CHI2;

};

void InitConst(struct ConstSet *Con)
{
  int i;
  for (i=0; i<NLAYER; ++i){
    Con->CHI0[i] = 0x1;
    Con->CHI1[i] = 0x1;
    Con->CHI2[i] = 0x1;
    Con->PT[i]   = 0x1;
    Con->D0[i]   = 0x1;
    Con->PHI[i]  = 0x1;
  }

  Con->IC_PT  = 0x0;
  Con->IC_D0  = 0x0;
  Con->IC_PHI = 0x0;

  Con->IC_CHI0 = 0x0;
  Con->IC_CHI1 = 0x0;
  Con->IC_CHI2 = 0x0;
}



void FitFunc( struct Comb *comb, struct ConstSet * con, struct Track *tk)
{
  // Init to zero

  int i, tmp0, tmp1, tmp2;
  tmp0=0.;
  tmp1=0.;
  tmp2=0.;

  // Scalar Products: Loop Over Layers
  for(i=0; i < NLAYER; ++i){
    tk->PT  += comb->Hit[i]*con->PT[i] ;
    tk->D0  += comb->Hit[i]*con->D0[i] ;
    tk->PHI += comb->Hit[i]*con->PHI[i];

    tmp0 += comb->Hit[i]*con->CHI0[i] ;
    tmp1 += comb->Hit[i]*con->CHI1[i] ;
    tmp2 += comb->Hit[i]*con->CHI2[i] ;
  }

  // Add Intercept
  tk->PT  += con->IC_PT ;
  tk->D0  += con->IC_D0 ;
  tk->PHI += con->IC_PHI;

  tmp0 += con->IC_CHI0;
  tmp1 += con->IC_CHI1;
  tmp2 += con->IC_CHI2;


  // Compute Final Track Fit Chi^2
  tk->CHI = tmp0*tmp0 + tmp1*tmp1 + tmp2*tmp2;

}

int TrkFit()
{
  struct ConstSet con;
  //struct Comb com = {0x0,0x0,0x0,0x0,0x0,0x0};
  struct Comb     com = {0x1,0x3,0x5,0x7,0xf,0x1f};
  struct Track    tk  = {0x0,0x0,0x0,0x0};
  
  InitConst(&con);
  //for(int i=0;i<1e3;i++){
  //  for(int j=0;j<1e3;j++){
  //    for(int k=0;k<1e3;k++){
  FitFunc(&com, &con, &tk);
  //}}}

  //printf("Comb %x , %x , %x \n", tk.PT, tk.D0, tk.CHI);

  return 0;
}
