
 #include <unistd.h>
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
 #include <sys/types.h>
 #include <signal.h>
 #include "rcc_error/rcc_error.h"
 #include "io_rcc/io_rcc.h"
 #include "cmem_rcc/cmem_rcc.h"
 #include "rcc_time_stamp/tstamp.h"
 #include "ROSGetInput/get_input.h"

 #ifdef DEBUG
 #define debug(x) printf x
 #else
 #define debug(x)
 #endif

 #define BUFSIZE 0x400000 /*bytes*/
 #define PREFILL 0xfeedbabe
 #define MAX_BURST_LEN 1

 /*types*/
 typedef struct
 {
 unsigned int opctrl; /*0x000*/
 unsigned int opstat; /*0x004*/
 unsigned int intmask; /*0x008*/
 unsigned int slidasctrl; /*0x00c*/
 unsigned int opfeat; /*0x010*/
 unsigned int swordcnt; /*0x014*/
 unsigned int bctrlw; /*0x018*/
 unsigned int ectrlw; /*0x01c*/
 unsigned int reserved[56]; /*0x020 - 0x0fc*/
 unsigned int reqfifo1; /*0x100*/
 unsigned int reqfifo2; /*0x104*/
 }T_solar_regs;


 /*globals*/
 static u_int isactive = 0, cont, shandle, sreg, offset;
 static u_int pkts_sent = 0, delta = 0;
 static u_int paddr, uaddr;
 static int bhandle;
 static T_solar_regs *solar;
 static unsigned int pcidefault[16]=
 {
 0x001710dc, 0x00800000, 0x02800001, 0x0000ff00, 0xfffffc00, 0x00000000, 0x00000000, 0x00000000,
 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x000001ff
 };
 static struct sigaction sa, sa2;

 int main()
 {
 u_int start, stop;
 double rate;

 start = solar->swordcnt;
 sleep(2);
 stop = solar->swordcnt;
 rate = (stop - start) / 2E6;
 printf("Data rate = %.3f Mwords/sec\n", rate);
 return(0);
 }
