 
//
// system headers
//
#include <stdio.h>
#include <iomanip>
#include <iostream>
#include <fstream>
#include <unistd.h>
#include <sched.h>
#include <vector>

#include "NodeUtils.hh"

//
// s32pci64 headers
//
extern "C" {
#include "s32pci64-filar.h"
#include "s32pci64-solar.h"
}

using namespace std;

#define FILAR_NUMBER_0 0 
#define FILAR_CHANNEL_MASK 0x1
#define FILAR_CHANNEL_0 0x1

#define rdtscl(low) \
     __asm__ __volatile__ ("rdtsc" : "=a" (low) : : "edx")


int main( int argc, char** argv) 
{

  unsigned  *dataptr_filar;
  unsigned data[10000];
  dataptr_filar = &(data[0]);


  cerr << "before filar_setup"  << endl;   
  // Yo, if you want this to work comment out the while loop 
  // in linkreset!!!  It checks for recovery off all 4 channels
  filar_setup_hola(FILAR_NUMBER_0, FILAR_CHANNEL_MASK); 
  cerr << "after filar_setup"  << endl;   


  int reqfifobufcount = 0;
  int reqfifobufused = 1;


  // ARM REQ FIFOs before going to event loop
  //  filar_setreq(FILAR_NUMBER_0, FILAR_CHANNEL_0, reqfifobufused);

  filar_setreq(FILAR_NUMBER_0, FILAR_CHANNEL_0, 4);


  //
  //  event loop
  // ---------------------------
  int nevent=1;
  int filar_err;
  int count=0, dumpcount=0;
  while( 1 )
    {
      
      // wait for data on the filar
      //
      filar_err=0;
      int fsize=0;

      // Write REQ FIFO for Cluster channel
      if (reqfifobufcount == reqfifobufused-1){
	filar_setreq(FILAR_NUMBER_0, FILAR_CHANNEL_0, reqfifobufused);
      }

      while (!fsize)
 	{
	  fsize=filar_receive_channel_ptr( FILAR_NUMBER_0, &filar_err, FILAR_CHANNEL_0, (unsigned*)(&data));
 	}

      for( int j=0; j<fsize; j++ )
	cout << "word " << dec << j << " : 0x" << hex <<  *(dataptr_filar+j) << endl;
      count++;
      cout << endl;
      cout << flush;
      reqfifobufcount++;
      if (reqfifobufcount == reqfifobufused) {
	reqfifobufcount = 0;
      }

      
    } // while 1
  
}
