#include <stdio.h>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <iomanip>
#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <string>
#include <unistd.h>
#include <sched.h>
#include <linux/types.h>
#include <sys/time.h>
#include "NodeUtils.hh"
using namespace std;

// s32pci64 headers
extern "C" {
#include "s32pci64-filar.h"
#include "s32pci64-solar.h"
}

//#define ADD_SLEEP

// Number of REQ FIFOs to arm in the beginning
#define FILAR_ARM 15
// PCI slot in which FILAR is installed
#define FILAR_SLOT 0 
#define FILAR_CHANNEL_0 0x1
#define FILAR_CHANNEL_1 0x2
#define FILAR_CHANNEL_MASK_0 0x1
#define FILAR_CHANNEL_MASK_1 0x2

#define FILAR_CHANNEL_MASK_BOTH 0x1|0x2

unsigned int str_to_uint(string v) {
  unsigned int result;
  istringstream buf(v);
  buf >> result;
  return result;
}

int main(unsigned long int argc, char* argv[]) {
  int urlchannel;
  cout << "==================================================="<< endl;
  cout << "Input argument:" << endl;
  cout << "0 = Channel 0;" << endl;
  cout << "1 = Channel 1;" << endl;
  cout << "2 = Both Channels." << endl;
  cout << "==================================================="<< endl;
  if(argc==2) urlchannel = str_to_uint(argv[1]);
  else urlchannel = 2;

  solar_setup(0);
  solar_slidas_off(0);
  // Set up two FILAR channels
  cerr << "FILAR: filar_setup with channel mask: " 
       << (FILAR_CHANNEL_MASK_BOTH) << endl;
  int setup_status = filar_setup_hola(FILAR_SLOT, FILAR_CHANNEL_MASK_BOTH);
  if(setup_status==-1) {
    cerr << "ERROR: failed to bring up FILAR" << endl;
    exit(0);
  }
  // url return line setup
  if (urlchannel == 0){
    filar_seturl(0, FILAR_CHANNEL_0, 15);
  }
  else if (urlchannel == 1){
    filar_seturl(0, FILAR_CHANNEL_1, 15);
  }
  else {
    filar_seturl(0, FILAR_CHANNEL_1, 15);
    filar_seturl(0, FILAR_CHANNEL_0, 15);
  }
  cout << "====================================================" << endl;
  cout << "Flow control disable URL has been sent." << endl;
  cout << "====================================================" << endl;
  return(0);
}
