#include <stdio.h>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <iomanip>
#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <string>
#include <unistd.h>
#include <sched.h>
#include <linux/types.h>
#include <sys/time.h>
#include "NodeUtils.hh"
using namespace std;

// s32pci64 headers
extern "C" {
#include "s32pci64-filar.h"
#include "s32pci64-solar.h"
}

// Number of REQ FIFOs to arm in the beginning
#define FILAR_ARM 15
// PCI slot in which FILAR is installed
#define FILAR_SLOT 0 
#define FILAR_CHANNEL_0 0x1
#define FILAR_CHANNEL_1 0x2
#define FILAR_CHANNEL_MASK_0 0x1
#define FILAR_CHANNEL_MASK_1 0x2

#define FILAR_CHANNEL_MASK_BOTH 0x1|0x2

unsigned int str_to_uint(string v) {
  unsigned int result;
  istringstream buf(v);
  buf >> result;
  return result;
}

int main(unsigned long int argc, char* argv[]) {
  int urlchannel = 2;
  int debugpattern = 0;
  cout << "==================================================="<< endl;
  cout << "Input argument:" << endl;
  cout << "0 = Channel 1;" << endl;
  cout << "1 = Channel 2;" << endl;
  cout << "2 = Both Channels." << endl;
  cout << "==================================================="<< endl;
  if(argc>=2) urlchannel = str_to_uint(argv[1]);
  if(argc>=3) debugpattern = str_to_uint(argv[2]);

  solar_setup(0);
  solar_slidas_off(0);
  // Set up two FILAR channels
  cerr << "FILAR: filar_setup with channel mask: " 
       << (FILAR_CHANNEL_MASK_BOTH) << endl;
  int setup_status = filar_setup_hola(FILAR_SLOT, FILAR_CHANNEL_MASK_BOTH);
  if(setup_status==-1) {
    cerr << "ERROR: failed to bring up FILAR" << endl;
    exit(0);
  }

  unsigned int FILAR_CHANNEL = urlchannel==0 ? FILAR_CHANNEL_0 : (urlchannel==1 ? FILAR_CHANNEL_1 : FILAR_CHANNEL_MASK_BOTH);

  if(!debugpattern) {
    filar_flowctrlenable(0, FILAR_CHANNEL);
  }
  else {
    filar_flowctrlenable_debug(0, FILAR_CHANNEL);
  }

  cout << "======================================================" << endl;
  cout << "Flow control enable URL has been sent." << endl;
  cout << "======================================================" << endl;
  return(0);
}
