#include <stdio.h>
#include <iomanip>
#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <cctype>
#include <string>
#include <unistd.h>
#include <sched.h>
#include <linux/types.h>
#include "NodeUtils.hh"
using namespace std;

// s32pci64 headers
extern "C" {
#include "s32pci64-filar.h"
#include "s32pci64-solar.h"
}

// Number of REQ FIFOs to arm in the beginning
#define FILAR_ARM 15
// PCI slot in which FILAR is installed
#define FILAR_SLOT 0 

#define FILAR_SLOT 0 
#define FILAR_CHANNEL_0 0x1
#define FILAR_CHANNEL_1 0x2
#define FILAR_CHANNEL_MASK_0 0x1
#define FILAR_CHANNEL_MASK_1 0x2

#define FILAR_CHANNEL_MASK_BOTH 0x1|0x2

int str_to_int(string v) {
  int result;
  istringstream buf(v);
  buf >> result;
  return result;
}
void capitalize(string& v) {
  for(unsigned int i=0;i<v.length();i++) {
    v[i] = tolower(v[i]);
  }
}

void print_help() {
  cerr << "SOLAR COMMANDS:" << endl;
  cerr << 
    "  si=solar_init | sc=solar_cardreset | sl=solar_linkreset" << endl;
  cerr <<
    "  son=solar_ureset_on | soff=solar_ureset_off" << endl;
  cerr << "FILAR COMMANDS:" << endl;
  cerr <<
    "  fi=filar_init | fc=filar_cardreset | fl=filar_linkreset <CHAN_MASK>" << endl;
  cerr << "  fon=filar_ureset_on | foff=filar_ureset_off" << endl;
  cerr << "SHORTCUT COMMANDS:" << endl;
  cerr <<
    "  set=si+fi+sc+fc" << endl;
}

int main( int argc, char* argv[]) {
  int chan;
  string input,com;
  unsigned int *dataptr_solar;

  // command line parser
  print_help();
  while(true) {
    com="";
    chan=-1;
    cout << "SOLAR_FILAR > ";
    getline(cin, input);
    istringstream iss(input);
    iss >> com;
    iss >> chan;
    capitalize(com);
    if(com=="exit") {
      exit(0);
    }
    else if(com=="set") {
      // shortcut to set everything up
      solar_ak0_init(0);
      filar_ak0_init(0);
      solar_ak1_cardreset(0);
      filar_ak1_cardreset(0);
    }
    else if(com=="s_init" || com=="si") {
      solar_ak0_init(0);
    }
    else if(com=="s_cardreset" || com=="sc") {
      solar_ak1_cardreset(0);
    }
    else if(com=="s_ureset_on" || com=="son") {
      solar_ak_ureset_on(0);
    }    
    else if(com=="s_ureset_off" || com=="soff") {
      solar_ak_ureset_off(0);
    }
    else if(com=="s_linkreset" || com=="sl") {
      solar_ak2_linkreset(0);
    }
    else if(com=="f_init" || com=="fi") {
      filar_ak0_init(0);
    }
    else if(com=="f_cardreset" || com=="fc") {
      filar_ak1_cardreset(0);
    }
    else if(com=="f_ureset_on" || com=="fon") {
      filar_ak_ureset_on(0);
    }    
    else if(com=="f_ureset_off" || com=="foff") {
      filar_ak_ureset_off(0);
    }
    else if(com=="f_linkreset" || com=="fl") {
      if(chan==FILAR_CHANNEL_MASK_0 || chan==FILAR_CHANNEL_MASK_1) {
	filar_ak2_linkreset(0,chan);
      } else {
	cerr << "Skipping filar linkreset: bad channel mask" << endl;
	continue;
      }
    }
    else {
      print_help();
      continue;
    }
  }
  
}
