 
//
// system headers
//
#include <stdio.h>
#include <iomanip>
#include <iostream>
#include <fstream>
#include <unistd.h>
#include <sched.h>
#include <stdlib.h>

using namespace std;

//
// s32pci64 headers
//
extern "C" {
#include "s32pci64-filar.h"
#include "s32pci64-solar.h"
}


#define rdtscl(low) \
     __asm__ __volatile__ ("rdtsc" : "=a" (low) : : "edx")




#define MAX_EVENTS 10000000
#define MAX_PACKET_WORDS     512
//#define DATA_DIR "/home/kristian/L2TStest/l2ts/l2ts/"


int main( int argc, char** argv) 
{

  unsigned int *dataptr_solar;

  // return packets
  unsigned int buff[12];
  unsigned int pattern, mode, length;
  
  if(argc!=4) {
    printf("Select the pattern switch (SW1) setting:\n");
    printf(" 0 = Testmode 1 = Walking 1\n");
    printf(" 2 = Walking 0 3 = FFFF/0000\n");
    printf(" 4 = AAAA/5555 5 = Random data\n");
    printf(" 6 = Random data, no control 7 = Random control\n");
    printf(" 8 = ROB blocks, 1 lenght 9 = ROB blocks, 3 lengths\n");
    printf("=============================================================\n");
    printf("Select the mode switch (SW2) setting:\n");
    printf(" 0 = RUN 1 = Single word\n");
    printf(" 2 = Single block 3 = 50 kHz\n");
    printf(" 4 = 75 kHz 5 = 90 kHz\n");
    printf(" 6 = 100 kHz 7 = 110 kHz\n");
    printf(" 8 = 125 kHz 9 = 150 kHz\n");
    printf("=============================================================\n");
    printf("Select the length switch (SW3) setting:\n");
    printf(" 0 = 52 byte (header only) 1 = 64 byte\n");
    printf(" 2 = 256 byte 3 = 512 byte\n");
    printf(" 4 = 1 kbyte 5 = 2 kbyte\n");
    printf(" 6 = 4 kbyte 7 = 8 kbyte\n");
    printf(" 8 = 16 kbyte 9 = 32 kbyte\n");
    exit(0);
  }
  else {
    pattern = atoi(argv[1]);
    mode = atoi(argv[2]);
    length = atoi(argv[3]);
    std::cerr << "pattern = " << pattern << " | mode = " << mode 
	      << " | length = " << length << std::endl;
    sleep(2);
  }

  // 
  // set up the s32pci64 cards
  //
  solar_setup(0);
  solar_slidas_off(0);
  cerr << "before filar_setup(0)" << endl;     
  dataptr_solar = solar_getbuffer(0);

  // enter slidas mode
  solar_slidas_config(0,pattern,length,mode);
  //solar_rodemul(0);
  solar_slidas_dump(0);

  //
  // read in the return packets
  //
  int size=0;
  int nevent=1;
  int filar_err;
 
  while( 1 )
    {
      for(int l=0;l<3;l++){
 	cout << "Input word to be sent" << endl;
        cin >> setw(8) >> hex >> buff[l];
        *(dataptr_solar+l) = buff[l];
      }
      //cin >> setw(8) >> hex >> *buff ;
      //*(dataptr_solar) = buff;
      //l++;
      size=3;

      solar_send(3,0);
      cout << "solar sent!" << endl;
      sleep(2);
    } //while 1
  
}
